"""Library of books."""

import random
from types import *
import avk_util

lst = []
authors = {}

def browse():
    """Browse full library."""

    book = choose(lst)
    if book:
        book.read()

def mk_authors_dict():
    """Create dict {'author': [books] ...}."""

    for book in lst:
        a = book.author
        if authors.has_key(a):
            authors[a].append(book)
        else:
            authors[a] = [book]

def choose(lst):
    """Pick an item out of lst.
    
    Returns chosen item; recursive - if a chosen item is a list, it
    chooses item out of that list.
    """

    term = avk_util.Term()
    if not lst:
        print "Not found."
        return None
    elif len(lst) == 1:
        item = lst[0]
        if avk_util.no("Choose %s?" % item, 'y'):
            item = None
    else:
        height, width = term.size()
        height -= 1
        n = 0
        while 1:
            for item in lst[n:n+height]:
                s =  "%4d) %s" % (n+1, item)
                print s[:width]
                n = n+1
            answer = raw_input("'h' for help---- ")
            if not answer:
                # no need to page, quit
                if len(lst) <= height/2:
                    return None
                else:
                    continue
            elif answer in ('q', "quit"):
                return None
            elif answer == 'h':
                print """
                <num>Enter  choose an item
                q           quit
                Enter       next page
                """
            else:
                try:
                    num = int(answer)
                    item = lst[num-1]
                    break
                except ValueError:
                    print "Error: invalid command."
    if type(item) == ListType:
        choose(item)
    else:
        return item

def pick_random():
    """Return random book."""

    return random.choice(lst)

def read_random():
    """Read random book."""

    book = pick_random()
    if avk_util.yes("Read %s?" % book, 'y'):
        book.read()

def find_title():
    """Find a book by title."""

    pattern = raw_input("Find title: ")
    results = []
    for book in lst:
        add_book = 1
        for pat in pattern.lower().split():
            if book.title.lower().find(pat) == -1:
                add_book = 0
                break
        if add_book:
            results.append(book)
    book = choose(results)
    if book:
        book.read()

def find_author():
    """Find a book by author."""

    pattern = raw_input("Find author: ")
    results = []
    for author in authors.keys():
        add = 1
        for pat in pattern.lower().split():
            if author.lower().find(pat) == -1:
                add = 0
                break
        if add:
            results.append(author)
    author = choose(results)
    if author:
        _books = authors[author]
        book = choose(_books)
        if book:
            book.read()

def browse_authors():
    """Browse list of authors."""

    author = choose(authors.keys())
    if author:
        _books = authors[author]
        book = choose(_books)
        if book:
            book.read()

# vim: sts=4:ts=8:et:sw=4
